#include "netio.h"

FILE* netio_connect(char *host_or_ip, int port){
	int fd, status;
	struct addrinfo hint, *res;
	struct sockaddr_in sa;
	FILE *fd_file;

	memset(&hint, 0, sizeof(hint));
	hint.ai_family=PF_INET;
	hint.ai_socktype=SOCK_DGRAM;

	status=getaddrinfo(host_or_ip, NULL, &hint, &res);
	if(status){
		fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(status));
		bail("unable to figure out host address", 1);
	}
	memcpy(&sa, res->ai_addr, sizeof(sa));
	sa.sin_port = htons(port);

	fd=socket(PF_INET, SOCK_DGRAM, 0);
	if(fd <0) {
		perror("making socket");
		bail("unable to create socket", 1);
	}

	status=connect(fd, (struct sockaddr*)&sa, sizeof(sa));
	if(status < 0) {
		perror("creating socket");
		bail("unable to create socket", 1);
	}

	fd_file=fdopen(fd, "w+");
	if(!fd_file) {
		perror("converting fd to FILE ptr");
		bail("unable to complete connection attempt", 1);
	}

	freeaddrinfo(res);
	return fd_file;
}
