#include "session.h"

static const char preamble[5] = { 0xff, 0xff, 0xff, 0xff, '\0' };
static const char eot = 0x00;

long session_rcon_establish(FILE *net_conn){
	long id=-1;
	fprintf(net_conn, "%s", preamble);
	fprintf(net_conn, "challenge rcon\n");
	fprintf(net_conn, "%c", eot);
	fflush(net_conn);
	fscanf(net_conn, "%*c%*c%*c%*cchallenge rcon %ld\n%*c", &id);
	return id;
}

int session_rcon_cmd(FILE *conn, long session_id, const char *cmd){
	char c, retval=0x00;
	short eot_count=0;

	fprintf(conn, "%s", preamble);
	fprintf(conn, "rcon %ld \"", session_id);
	if(g_config.password) fprintf(conn, "%s", g_config.password);
	fprintf(conn, "\" %s\n", g_config.cmd);
	fprintf(conn, "%c", eot);
	fflush(conn);
	fscanf(conn, "%*c%*c%*c%*c%c", &retval);
	if(retval=='l')fprintf(stderr, "server returned success\n");
	else fprintf(stderr, "server returned something wierd :%c\n", retval);
	fflush(NULL);
	c=fgetc(conn);
	while(420){
		if(c==eot) eot_count++;
		else { 
			fprintf(stdout, "%c", c);
			fflush(stdout);
		}
		if(eot_count == 2) break;
		else c=fgetc(conn);
	}
	return 0;
}

int session_client_cmd(FILE *conn, const char *cmd){
	char c, retval=0x00;
	short eot_count=0;

	fprintf(conn, "%s", preamble);
	fprintf(conn, "%s\n", g_config.cmd);
	fprintf(conn, "%c", eot);
	fflush(conn);
	fscanf(conn, "%*c%*c%*c%*c%c", &retval);
	if(retval=='l')fprintf(stderr, "server returned success\n");
	else fprintf(stderr, "server returned something wierd :%c\n", retval);
	fflush(NULL);
	c=fgetc(conn);
	while(420){
		if(c==eot) eot_count++;
		else { 
			fprintf(stdout, "%c", c);
			fflush(stdout);
		}
		if(eot_count == 2) break;
		else c=fgetc(conn);
	}
	return 0;
}
